/*

 Copyright (c) [2023] [pcm]
 [pcm-coordinator] is licensed under Mulan PSL v2.
 You can use this software according to the terms and conditions of the Mulan PSL v2.
 You may obtain a copy of Mulan PSL v2 at:
          http://license.coscl.org.cn/MulanPSL2
 THIS SOFTWARE IS PROVIDED ON AN "AS IS" BASIS, WITHOUT WARRANTIES OF ANY KIND,
 EITHER EXPaRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO NON-INFRINGEMENT,
 MERCHANTABILITY OR FIT FOR A PARTICULAR PURPOSE.
 See the Mulan PSL v2 for more details.

*/

package cloud

import (
	"context"
	"errors"
	"github.com/zeromicro/go-zero/core/logx"
	"gitlink.org.cn/JointCloud/pcm-coordinator/internal/participant/cloud"
	"gitlink.org.cn/JointCloud/pcm-coordinator/internal/svc"
	container "gitlink.org.cn/JointCloud/pcm-coordinator/internal/types/cloud"
	"net/http"
)

type ContainerGetLogic struct {
	logx.Logger
	ctx    context.Context
	svcCtx *svc.ServiceContext
}

func NewContainerGetLogic(ctx context.Context, svcCtx *svc.ServiceContext) *ContainerGetLogic {
	return &ContainerGetLogic{
		Logger: logx.WithContext(ctx),
		ctx:    ctx,
		svcCtx: svcCtx,
	}
}

func (l *ContainerGetLogic) ContainerGet(req *container.GetParam) (resp interface{}, err error) {
	param := &cloud.GetParam{
		Name: req.Name,
	}
	get, err := l.svcCtx.Cloud.ContainerGet(req.ClusterId, param)
	if err != nil {
		return nil, err
	}
	if get.Code != http.StatusOK {
		return nil, errors.New(get.Message)
	}
	resp = get.Data
	return
}
